$title {CGEf
display "@ {CGEf";
$ontext
Time-stamp:     <2017-01-04 13:08:49 st>
First-written:  <2015/11/18>

Unit (P):
+ zf[^́u10~v
+ CO2roʂ́uMtCO2 (_YfSg)v
+ roi (Yf) ́u1000~/CO2gv

$offtext

* $setglobal fl_vlsup 1
$setglobal fl_wc 0
$setglobal fl_vinv 0

$setglobal debug_mode 1

*       f[^̑IBjapan_25x17 ̓eXgp̏ȃf[^B
$setglobal data_name japan_48x40
* $setglobal data_name japan_25x17

$setglobal bau_check 0

*       ViI
$if not setglobal scn_name $setglobal scn_name scn_default

*       f[^̎w
$if not setglobal data_name $setglobal data_name japan_25x17

*       Ō̔N (up to 2030):
$if not setglobal t_run $setglobal t_run 2015

*       CO2Kn߂ŏ̔N
$if not setglobal t_lim $setglobal t_lim 2010

$if not setglobal fl_vlsup $setglobal fl_vlsup 0

*       ςȂ1
$if not setglobal fl_vinv $setglobal fl_vinv 1

*       Potential Labor / Actual labor force
$if not setglobal fl_lf $setglobal fl_lf 0.667

*       Ɨ]ɂ̊ԂEOS
$if not setglobal elas_lf $setglobal elas_lf 0.66

*       Energy֌WEOS
$if not setglobal eos_ene $setglobal eos_ene 1

*       Đ\GlM[p̐ݒt@C
$if not setglobal file_rene $setglobal file_rene ./scenarios/rene_setting_default.gms

$if not setglobal debug_mode $setglobal debug_mode 0

$if not setglobal bau_check $setglobal bau_check 0

*       Wage curve model:
$if not setglobal fl_wc $setglobal fl_wc 0

*       Elasticity of unemployment to real wage rate:
$if not setglobal wc_elas $setglobal wc_elas -0.1

*       Scale for unemployment rate
$if not setglobal wc_urate_sc $setglobal wc_urate_sc 1

*       Model type
$if not setglobal fl_mcp $setglobal fl_mcp 0

parameter
    fl_vlsup      Variable labor supply
    fl_vinv
;
fl_vlsup = %fl_vlsup%;
fl_vinv = %fl_vinv%;
display fl_vlsup, fl_vinv;
        
*       --------------------------------------------------------------
*       W

*       wfp̏W
set
    t_all       Year     / 2005*%t_run% /
*     t(t_all)    Year     / 2005, 2010, 2015, 2020, 2025, 2030 /
*     t(t_all)    Year     / 2005, 2010, 2015 /
    t(t_all)    Year     / 2005/
    t_lst(t)    Ō̔N
    t_fst(t)    ŏ̔N
    t_run(t)    f
    t_lim(t)    Kۂ
;
t_fst(t)$(ord(t) = 1) = yes;
t_lst(t)$(ord(t) eq card(t)) = yes;
display t, t_fst, t_lst;

t_run(t)$(ord(t) le (%t_run% - 2000)/5) = yes;
t_lim(t)$((ord(t) ge (%t_lim% - 2000)/5) and t_run(t)) = yes;
display t_run, t_lim;

*       File name for displaying title in DOS window.
file titlemaker /'titlemaker_%scn_name%.cmd'/;
putclose titlemaker '@title Solving scenario = %scn_name%' /;
execute 'titlemaker_%scn_name%.cmd';

*       --------------------------------------------------------------
*       f[^t@C
$setglobal data_file ./aggr_data/%data_name%.gdx

*       Wt@C
$setglobal set_file ./set/%data_name%.set

*       Wt@C
$setglobal set_file_sub ./set/%data_name%_sub.set

* * gams-include-file: ./set/japan_25x17.set 
* gams-include-file: ./set/japan_48x40.set 
$include %set_file% 

* * gams-include-file: ./set/japan_25x17_sub.set 
* gams-include-file: ./set/japan_48x40_sub.set 
$include %set_file_sub% 

display row, col, va, fd;
display es, agr, f_f, ely_s, ene, sen;
display e_ene_c, e_ene_nc;

alias (row,i), (row,ii), (col,j), (col,jj), (es,ess);
display i, j;

set oth_s(j)    ̑̕;
oth_s(j) = no;
oth_s(j)$((not agr(j)) and (not f_f(j)) and (not ely_s(j)) and (not sen(j))) = yes;
display oth_s;

set     so      \[X  / dom, imp, oth /
        set_vt(i,j)
;
scalar     sf_data      / 1e+3 /;

set
    reg_f(j)    K镔
;
reg_f(j) = yes;
display reg_f;

parameter
    reg_c       Non-zero if HH is regulated
;
reg_c = 1;
display reg_c;
       
parameter
    io_u(*,*,*)         "Aggregated IO table (U table)"
    io_v(*,*)           "Aggregated IO table (V table)"
    io_fd(*,*,*)        "Aggregated IO table (final demand)"
    io_va(*,*)          "Aggregated IO table (value added)"
    io_co2(*,*)         "CO2 emissions (MtCO2)"

    io_u_(*,*,*)        "Aggregated IO table (U table)"
    io_v_(*,*)          "Aggregated IO table (V table)"
    io_fd_(*,*,*)       "Aggregated IO table (final demand)"
    io_va_(*,*)         "Aggregated IO table (value added)"
;

$gdxin '%data_file%'
$load io_u, io_v, io_fd, io_va, io_co2, set_vt

display io_u, io_v, io_fd, io_va, io_co2, set_vt;

io_u_(row,col,so) = io_u(row,col,so) / sf_data;
io_fd_(row,fd,so) = io_fd(row,fd,so) / sf_data;
io_va_(va,col) = io_va(va,col) / sf_data;
io_v_(row,col) = io_v(row,col) / sf_data;
display io_u_, io_v_, io_fd_, io_va_;

parameters
    chk_io
    chk_va_fd
    chk_imp
    chk_sign_io         }CiX̗vf\
    chk_io_
;
$macro mc_chk_io \
    chk_io(col,"col_sum") = \
    sum((row,so), io_u_(row,col,so)) + sum(va, io_va_(va,col)); \
    chk_io(row,"row_sum") = \
    sum((col,so), io_u_(row,col,so)) + sum((fd,so), io_fd_(row,fd,so)); \
    chk_io("sum","col_sum") = sum(col, chk_io(col,"col_sum")); \
    chk_io("sum","row_sum") = sum(row, chk_io(row,"row_sum")); \
    display chk_io;

$macro mc_chk_va_fd \
    chk_va_fd(col,"va") = sum(va, io_va_(va,col)); \
    chk_va_fd(row,"fd") = sum((fd,so), io_fd_(row,fd,so)); \
    chk_va_fd("sum","va") = sum(col, chk_va_fd(col,"va")); \
    chk_va_fd("sum","fd") = sum(row, chk_va_fd(row,"fd")); \
    display chk_va_fd;

$macro mc_chk_imp \
    chk_imp(row,"imp") \
    = sum(col, io_u_(row,col,"imp")) + sum(fd, io_fd_(row,fd,"imp")); \
    chk_imp(row,"imp_") = \
    - (io_fd_(row,"imp","oth") + io_fd_(row,"imt","oth")); \
    chk_imp(row,"imp-imp_") = chk_imp(row,"imp") - chk_imp(row,"imp_"); \
    display chk_imp;

$macro mc_chk_sign_io \
    chk_sign_io(row,col,so) = 0; \
    chk_sign_io(va,col,so) = 0; \
    chk_sign_io(row,fd,so) = 0; \
    chk_sign_io(row,col,so)$(io_u_(row,col,so) < 0) = io_u_(row,col,so); \
    chk_sign_io("cap",col,"oth")$(io_va_("cap",col) < 0) = io_va_("cap",col); \
    chk_sign_io(row,fd,so)$(io_fd_(row,fd,so) < 0) = io_fd_(row,fd,so); \
    chk_sign_io(row,"imp",so) = 0; \
    chk_sign_io(row,"imt",so) = 0; \
    display chk_sign_io;

$macro mc_chk_io_ \
    chk_io_(col,"col_sum") = \
    sum((row,so), io_u_(row,col,so)) + sum(va, io_va_(va,col)); \
    chk_io_(row,"row_sum") = \
    sum((col,so), io_u_(row,col,so)) + sum((fd,so), io_fd_(row,fd,so)); \
    chk_io_("sum","col_sum") = sum(col, chk_io_(col,"col_sum")); \
    chk_io_("sum","row_sum") = sum(row, chk_io_(row,"row_sum"));\
    chk_io_(col,"col_sum_") = sum(row, io_v_(row,col));\
    chk_io_(row,"row_sum_") = sum(col, io_v_(row,col));\
    chk_io_("sum","col_sum_") = sum(col, chk_io_(col,"col_sum_")); \
    chk_io_("sum","row_sum_") = sum(row, chk_io_(row,"row_sum_"));\
    chk_io_(col,"col_diff") = chk_io_(col,"col_sum") - chk_io_(col,"col_sum_"); \
    chk_io_(row,"row_diff") = chk_io_(row,"row_sum") - chk_io_(row,"row_sum_"); \
    chk_io_("sum","col_diff") = chk_io_("sum","col_sum") - chk_io_("sum","col_sum_"); \
    chk_io_("sum","row_diff") = chk_io_("sum","row_sum") - chk_io_("sum","row_sum_"); \
    display chk_io_;

display "@ f[^CO";
mc_chk_io;
mc_chk_va_fd;
mc_chk_imp;
mc_chk_sign_io;
mc_chk_io_;

parameter
    chk_byproduct;

chk_byproduct(row,col)$(sum(so, chk_sign_io(row,col,so)) < 0)
    = - sum(so, chk_sign_io(row,col,so));
display chk_byproduct;

*       --------------------------------------------------------------
*       ȉŃf[^C
$ontext
ŏIv}CiX̗vfB
$offtext
display io_fd_;
io_fd_(row,fd,so)$chk_sign_io(row,fd,so) = 0;

$ontext
EAv𑝉ƂɑΉAe̗Aʂ𑝉B
$offtext
io_fd_(row,"imp","oth")
    = io_fd_(row,"imp","oth")
    + sum(fd, chk_sign_io(row,fd,"imp"));
display io_fd_;

$ontext
Eɑ΂vɂẮAƌv̍̕ʂƂđgւB
$offtext
io_fd_(row,"hhc","oth")
    = sum(fd, chk_sign_io(row,fd,"dom"));
display io_fd_;

$ontext
+ ԓɂ镉̗vfB
+ YĈB
+ U\V\CB

$offtext
io_v_(row,col)$chk_byproduct(row,col)
    = io_v_(row,col) + chk_byproduct(row,col);
io_u_(row,col,"dom")$chk_byproduct(row,col) = 0;

display "@ f[^C";
mc_chk_io;
mc_chk_va_fd;
mc_chk_imp;
mc_chk_sign_io;
mc_chk_io_;

set_vt(row,col) = no;
set_vt(row,col)$io_v_(row,col) = yes;
display set_vt;

*       ----------------------------------------------------------------------
*       Parameters for labor market:
display "@ Parameters for labor market:";
$ontext
Ɨf[^
EuJ͒v2005N12: 4.4%

$offtext
parameter
    fl_wc       Wage curve model
    wc_elas     Wage curve elasticity
    v0          Benchmark real wage rate
    ur0         Benchmark unemployment rate
    unempr0     Benchmark unemployment
;
fl_wc = %fl_wc%;
wc_elas = %wc_elas%;
v0 = 1;

display fl_wc, wc_elas, v0;

ur0 = 4.4 / 100;
ur0 = ur0 * %wc_urate_sc%;
display ur0;

*       --------------------------------------------------------------
*       p[^̒`
display "@ p[^̒`";
parameter
        vqq0(*,*)       Yz
        vq0(*)          ʐYz
;
vqq0(i,j) = io_v_(i,j);
display vqq0;

vq0(j) = sum(i, vqq0(i,j));
display vq0;

parameters
    vintd0(i,j)         ԓz
    vintdd0(i,j)        ԓzij
    vintdi0(i,j)        ԓziAj
    vkd0(j)             {z
    vld0(j)             Jz
    vltax0(j)           J
    vqtax0(j)           YŊz
;

vintdd0(i,j)$(io_u_(i,j,"dom") > 0) = io_u_(i,j,"dom");
vintdi0(i,j)$(io_u_(i,j,"imp") > 0)  = io_u_(i,j,"imp");
vintd0(i,j) = vintdd0(i,j) + vintdi0(i,j);
display vintdd0, vintdi0, vintd0;

vkd0(j) = io_va_("cap",j);
vld0(j) = io_va_("lab",j);
vltax0(j) = io_va_("ltx",j);
vqtax0(j) = io_va_("idt",j);
display vkd0, vld0, vltax0, vqtax0;

parameters
    sh_nd(j)            ynVFA
    sh_rd(j)            VFA
    vnd0(j)             yn
    vrd0(j)             
;

sh_nd(j)$agr(j) = 0.5;
sh_rd(j)$f_f(j) = 0.5;
sh_rd(j)$ely_s(j) = 0.5;

vnd0(j) = sh_nd(j) * vkd0(j);
vkd0(j) = vkd0(j) - vnd0(j);

vrd0(j) = sh_rd(j) * vkd0(j);
vkd0(j) = vkd0(j) - vrd0(j);
display vkd0, vnd0, vkd0;

parameters
    vcdd0(i)            ԏzij
    vcdi0(i)            ԏziAj
    vcd0(i)             ԏz
    vcon0               z
;
vcdd0(i) = io_fd_(i,"hhc","dom");
vcdi0(i) = io_fd_(i,"hhc","imp");
vcd0(i) = vcdd0(i) + vcdi0(i);
display vcdd0, vcdi0, vcd0;

vcon0 = sum(i, vcd0(i));
display vcon0;

$ontext
EƂĂ̖ʂϐ𓱓
$offtext
parameters
    vdem_hh0    ƌv̍̎vʁi͊Oj
;
vdem_hh0(i) = io_fd_(i,"hhc","oth");
display vdem_hh0;

parameters
    vgdd0(i)            {zij
    vgdi0(i)            {ziAj
    vgd0(i)             {z
    vgov0               {z
;
vgdd0(i) = io_fd_(i,"gvc","dom");
vgdi0(i) = io_fd_(i,"gvc","imp");
vgd0(i) = vgdd0(i) + vgdi0(i);
display vgdd0, vgdi0, vgd0;

vgov0 = sum(i, vgd0(i));

parameters
    vidd0(i)            zij
    vidi0(i)            ziAj
    vid0(i)             z
    vinv0               z
;
vidd0(i) = io_fd_(i,"inv","dom");
vidi0(i) = io_fd_(i,"inv","imp");
vid0(i) = vidd0(i) + vidi0(i);
display vidd0, vidi0, vid0;

vinv0 = sum(i, vid0(i));
display vinv0;

parameters
    vexp0(i)    Aoz
;
vexp0(i) = io_fd_(i,"exp","oth");
display vexp0;

parameters
    vimp0(i)    Az
    vimptax0(i) ֐Ŋz
    vimp_0(i)
;
vimp0(i) = - io_fd_(i,"imp","oth");
vimptax0(i) = - io_fd_(i,"imt","oth");
display vimp0, vimptax0;

vimp_0(i) = vimp0(i) + vimptax0(i);
display vimp_0;

parameters
    vdo0(i)     Y
    vdd0(i)     "Y"
    vdx0(i)     "YAo"
;
vdo0(i) = sum(j, vqq0(i,j));
display vdo0;

vdx0(i) = vexp0(i);
vdd0(i) = vdo0(i) - vdx0(i);
display vdx0, vdd0;

parameter
    va0(i,*)    Armington
;

parameter
    end_res(j)  
    end_res0(j) 
    end_lnd(j)  yn
    end_lnd0(j) yn
;
end_res(j) = vrd0(j);
end_lnd(j) = vnd0(j);
end_res0(j) = end_res(j);
end_lnd0(j) = end_lnd(j);

parameter
    end_cap     {
    end_cap0    {
;
end_cap = sum(j, vkd0(j));
end_cap0 = end_cap;

*       --------------------------------------------------------------
*       ]ɁEJ

parameter
    end_lab     J
    end_lab_    J for model wc
    vsup0       J
    vlei0       ]Ɏv
;
*       J
vsup0 = sum(j, vld0(j));

*       J
end_lab = vsup0*(1 + %fl_lf% * fl_vlsup);

*       ]Ɏv
vlei0 = end_lab - vsup0;

display vsup0, end_lab, vlei0;

*       Adjustment labor supply:
end_lab_ = end_lab / (1 - ur0);

*       Benchmark unemployment:
unempr0 = ur0 * end_lab_;
display end_lab, end_lab_, unempr0;

parameter
    vca0_       Current account
    vca0
;
vca0_(i,"exp") = vexp0(i);
vca0_(i,"imp") = vimp0(i);
vca0_(i,"exp-imp") = vexp0(i) - vimp0(i);
vca0_("sum","exp") = sum(i, vexp0(i));
vca0_("sum","imp") = sum(i, vimp0(i));
vca0_("sum","exp-imp") = sum(i, vexp0(i) - vimp0(i));
display vca0_;

vca0 = vca0_("sum","exp-imp");
display vca0;

parameters
    vsave0      Saving
;
vsave0 = vinv0;

parameters
    vutil0      zIȌp
;
vutil0 = vsave0$fl_vinv + vcon0 + vlei0$fl_vlsup;
display vutil0;

parameters
    rt_m        ֐ŗ
    rt_q        Yŗ
    rt_l        Jŗ
    rt_li       Jŗ
    rt_m0       ֐ŗ
    rt_q0       Yŗ
    rt_l0       Jŗ
    rt_li0      Jŗ
;

rt_m(i) = 0;
rt_m(i)$vimp0(i) = vimptax0(i) / vimp0(i);
display rt_m;

rt_q(j) = 0;
rt_q(j)$vq0(j) = vqtax0(j) / vq0(j);
display rt_q;

rt_l(j) = 0;
rt_l(j)$vld0(j) = vltax0(j) / vld0(j);
display rt_l;

rt_li = 0;

rt_m0(i) = rt_m(i);
rt_q0(j) = rt_q(j);
rt_l0(j) = rt_l(j);
rt_li0 = rt_li;

*       --------------------------------------------------------------
*       Check

parameter chk_sec_, chk_goods_, chk_va_fd_, chk_imp_;

chk_sec_(j,"cost")
    = sum(i, vintd0(i,j)) + vld0(j) + vltax0(j) + vkd0(j) + vnd0(j) + vrd0(j) + vqtax0(j);
chk_sec_(j,"reve")
    = vq0(j);
chk_sec_(j,"profit") = chk_sec_(j,"reve") - chk_sec_(j,"cost");
display chk_sec_;

chk_goods_(i,"dem")
    = sum(j, vintd0(i,j)) + vcd0(i) + vgd0(i) + vid0(i) + vexp0(i)
    + vdem_hh0(i);
chk_goods_(i,"sup")
    = sum(j, vqq0(i,j)) + vimp0(i) + vimptax0(i);
chk_goods_(i,"dem-sup") = chk_goods_(i,"dem") - chk_goods_(i,"sup");

chk_goods_(i,"dem_d")
    = sum(j, vintdd0(i,j)) + vcdd0(i) + vgdd0(i) + vidd0(i) + vexp0(i) + vdem_hh0(i);
chk_goods_(i,"sup_d") = sum(j, vqq0(i,j));
chk_goods_(i,"dem-sup_d") = chk_goods_(i,"dem_d") - chk_goods_(i,"sup_d");
display chk_goods_;

chk_va_fd_(j,"va") = vld0(j) + vkd0(j) + vltax0(j) + vqtax0(j) + vnd0(j) + vrd0(j);
chk_va_fd_(i,"fd") = vcd0(i) + vgd0(i) + vid0(i) + vexp0(i)
    - vimp0(i) - vimptax0(i) + vdem_hh0(i);
chk_va_fd_("sum","va") = sum(j, chk_va_fd_(j,"va"));
chk_va_fd_("sum","fd") = sum(i, chk_va_fd_(i,"fd"));
display chk_va_fd_;

chk_imp_(i,"imp")
    = sum(j, vintdi0(i,j)) + vcdi0(i) + vgdi0(i) + vidi0(i);
chk_imp_(i,"imp_") = vimp0(i) + vimptax0(i);
chk_imp_(i,"diff") = chk_imp_(i,"imp") - chk_imp_(i,"imp_");
display chk_imp_;

parameter
    vlumpt0     Lump-sum tax
    v_g_chk     {Exo
;
v_g_chk("exp") = vgov0;
v_g_chk("rev") =
    sum(i, rt_m0(i)*vimp0(i))
    + sum(j, rt_l0(j)*vld0(j))
    + sum(j, rt_q0(j)*vq0(j));
v_g_chk("exp-rev") = v_g_chk("exp") - v_g_chk("rev");
display v_g_chk;

vlumpt0 = v_g_chk("exp-rev");
display vlumpt0;

*       --------------------------------------------------------------
*       Energy input
parameters
    vae0(j)     Energy input
    vkle0(j)    Energy input + KL
;
vae0(j) = sum(i$ene(i), vintd0(i,j));
vae0(j)$sen(j) = sum(i$e_ene_c(i,j), vintd0(i,j)) + sum(i$ely(i), vintd0(i,j));
display vae0;

vkle0(j) = vae0(j) + vkd0(j) + vld0(j);
display vkle0;

*       --------------------------------------------------------------
*       {XgbN
parameters
    k_2005      2005N̎{XgbN
    ratio_k
;
$ontext
[st] f[^̃`FbN
{XgbÑf[^

SNAXgbN҂̗L`Œ莑Y{`Œ莑Yc
+ 2004: 1125306.3+20361.6=1145667.9
+ 2005: 1139088.4+21327.9=1160416.3

JIP2009̎{XgbN(2000N)~SNAŒ莑{`ft[^
+ 2004: 1475985.9*0.940=1387426.8
+ 2005: 1498399.9*0.941=1409994.3
$offtext

k_2005 = 1409994.3;
ratio_k = k_2005 / end_cap;
display k_2005;

parameters
    chk_oil
    chk_coa
;

chk_oil("v",j) = vintd0("oil",j);
chk_oil("v","sum") = sum(j, chk_oil("v",j));
chk_oil("%",j) = 100 * chk_oil("v",j) / chk_oil("v","sum");
display chk_oil;

chk_coa("v",j) = vintd0("coa",j);
chk_coa("v","sum") = sum(j, chk_coa("v",j));
chk_coa("%",j) = 100 * chk_coa("v",j) / chk_coa("v","sum");
display chk_coa;

*       --------------------------------------------------------------
*       CO2f[^
display "@ CO2f[^";

parameter
    qco2(i,j)   "CO2 from industries"
    qco2c(i)    "CO2 from HH"
    co2use(*)   "CO2 from industries and HH"
    co2so(i)    "CO2 by source"
    co2_2005    "Total CO2 emissions (MtCO2)"
    co2_lim     Limit on CO2
    co2_lim0
    co2_lim_f0
    co2_lim_c0
    co2_lim_f
    co2_lim_c
    chk_qco2
;
qco2(es,j) = io_co2(es,j);

chk_qco2(i,j) = 0;
loop((i,j),
    if((io_co2(i,j) and (not vintd0(i,j))),
        chk_qco2(i,j) = io_co2(i,j);
    );
);
display chk_qco2;

qco2(i,j)$chk_qco2(i,j) = 0;
display qco2;

qco2c(es) = io_co2(es,"hhc");
display qco2c;

co2use(j) = sum(i, qco2(i,j));
co2use("CON") = sum(i, qco2c(i));
display co2use;

co2so(i) = sum(j, qco2(i,j)) + qco2c(i);
display co2so;

co2_2005 = sum(i, co2so(i));
display co2_2005;

co2_lim_f0(j) = sum(i, qco2(i,j));
co2_lim_c0 = sum(i, qco2c(i));
co2_lim_f(j) = co2_lim_f0(j);
co2_lim_c = co2_lim_c0;
display co2_lim_f0, co2_lim_c0;
       
co2_lim0 = co2_2005;
co2_lim = co2_lim0 * 10;
display co2_lim;

*       --------------------------------------------------------------
*       d
$ontext
{GlM[oόvʕ̓jbgiҁji2014jwGlM[Eoϓvv
i2014NŁjxCʍc@lȃGlM[Z^[

d͎
i5jdd͗ (100kWh)

2005N
: 86350
Η: 761841
q: 304755
v: 1157926

(+
86350
761841
304755
)
1152946

2005N̑Sdd͗ʂ́u11530kWhvB

$offtext

parameter
    ely_q0(*)   N̔dʁi10kWhj
    ely_scale   
;
ely_q0("e_f") = 761841 / 1000;
ely_q0("e_n") = 304755 / 1000;
ely_q0("e_h") = 86350 / 1000;
ely_q0("total") = sum(ely_s, ely_q0(ely_s));
display ely_q0;

ely_scale = ely_q0("total") / vdo0("ely");
display ely_scale;

*       --------------------------------------------------------------
*       e͐p[^
display "@ e͐p[^";

parameters
    e_cc        "EOS: "
    e_ec        "EOS: GlM["
    e_nec       "EOS: GlM["
    e_kl        "EOS: { vs J"
    e_res       "EOS:  vs 񎑌"
    e_lnd       "EOS: yn vs yn"
    e_kle       "EOS: {EJ vs GlM["
    e_ely       "EOS: d vs d̓GlM["
    e_ene       "EOS: GlM["
    e_dm        "EOS: Armingtone͐"
    e_des       "EOS:  vs Ao"
;
e_cc = 0.5;
e_ec = 1;
e_nec = 1;
display e_cc, e_ec, e_nec;

e_kl(j) = 1.0;
e_ely(j) = 0.5 * %eos_ene%;
e_ene(j) = 1.0 * %eos_ene%;
display e_kl, e_ely, e_ene;

e_kle(j) = 0.5;
display e_kle;

e_res(j)$f_f(j) = 0.1;
e_res("e_f") = 0.1;
e_res("e_h") = 0.0;
e_res("e_n") = 0.0;
display e_res;

e_lnd(j) = 0.5;
e_dm(i) = 4;
e_des(i) = 2;
display e_lnd, e_dm, e_des;

parameters
    s_f         Scale factor
    s_f_g
    s_f_lab
;
s_f = 1;
s_f_g = 1;
s_f_lab = 1;

*       ----------------------------------------------------------------------
*       Technology parameters:
parameter
    tn_l        "Zpp[^iJYj"
    tn_e        "Zpp[^iAEEIj"
    ;
tn_l(j) = 1;
tn_e(i,j) = 1;
tn_e(i,"hh") = 1;

*       --------------------------------------------------------------
*       Đ\GlM[
set
    rene        Đ\GlM[
    / r_s       z
      r_w       
      /
    all_e       SĂ̓d͕
    / e_f, e_n, e_h, r_s, r_w /
;
display rene, all_e;

parameters
    fl_rene(rene)       YesȂĐ\GlM[ɂ锭d
;
fl_rene(rene) = yes;
display fl_rene;

parameters
    rq_rene_sh  Đ\GlM[pReference share
    rq_rene     Đ\GlM[pReference quantity
    rene_mu     Đ\GlM[p̃}[NAbv
;
parameters
    end_rene(rene)      Đ\GlM[p̎̕
    end_rene0(rene)     Đ\GlM[p̎̕;
;
parameters
    e_rene_res(rene)    "EOS:  vs 񎑌"
;
parameters
    tn_rene(rene)       Yp[^
    t_gr_rene(t,rene)   Yp[^㏸
    t_rene_path(t,rene) Yp[^̃pX
;
parameters
    fl_fit              Flag for feed-in tariff
    fl_fit_e            Flag for endogenous subsidy rate
    s_fit_(rene)        Subsidy rates for feed-in tariff
    s_fit_0(rene)       Subsidy rates for feed-in tariff
    s_fit(rene)         Subsidy rates for feed-in tariff in model
    s_fit_path(t,rene)
    s_fit_path0(t,rene)
;
fl_fit = 1;
fl_fit_e = 0;
display fl_fit, fl_fit_e;

* gams-include-file: ./scenarios/rene_setting_default.gms
$include %file_rene%

display rq_rene_sh, rq_rene, rene_mu;

end_rene(rene) = end_rene0(rene);
display end_rene0;

display e_rene_res;

display s_fit_, s_fit, s_fit_path;

display tn_rene, t_gr_rene, t_rene_path;

*       --------------------------------------------------------------
*       Benchmark data check
parameters
    chk_VA_sec          Value added by sector
    chk_out_sec         Output by sector
    chk_CO2_use         CO2 emissions by sector
    chk_CO2_use_int     "tCO2/Million Yen"
    chk_ely_use
    chk_ind_CO2
    chk_ind_CO2_use     CO2 emissions by sector
    chk_ind_CO2_use_int CO2 emissions by sector
;

chk_ely_use(j,"Value") = vintd0("ely",j);
chk_ely_use("HHC","Value") = vcd0("ely");
chk_ely_use("sum","Value") = sum(j, chk_ely_use(j,"Value")) + chk_ely_use("HHC","Value");

chk_ely_use(j,"%") = 100 * chk_ely_use(j,"Value") / chk_ely_use("sum","Value");
chk_ely_use("HHC","%") = 100 * chk_ely_use("HHC","Value") / chk_ely_use("sum","Value");
chk_ely_use("sum","%") = 100 * chk_ely_use("sum","Value") / chk_ely_use("sum","Value");

display chk_ely_use;

chk_ind_CO2 = sum(i, qco2(i,"e_f"));

display chk_ind_CO2;

chk_VA_sec(j,"Value") = vld0(j) + vkd0(j) + vltax0(j) + vqtax0(j) + vnd0(j) + vrd0(j);
chk_VA_sec("sum","Value") = sum(j, chk_VA_sec(j,"Value"));

chk_VA_sec(j,"%") = 100 * chk_VA_sec(j,"Value") / chk_VA_sec("sum","Value");
chk_VA_sec("sum","%") = 100 * chk_VA_sec("sum","Value") / chk_VA_sec("sum","Value");

display chk_VA_sec;

chk_out_sec(j,"Value") = sum(i, vqq0(i,j));
chk_out_sec("sum","Value") = sum(j, chk_out_sec(j,"Value"));

chk_out_sec(j,"%") = 100 * chk_out_sec(j,"Value") / chk_out_sec("sum","Value");
chk_out_sec("sum","%") = 100 * chk_out_sec("sum","Value") / chk_out_sec("sum","Value");

display chk_out_sec;

chk_CO2_use(j,"MtCO2") = sum(i, qco2(i,j));
chk_CO2_use("HHC","MtCO2") = sum(i, qco2c(i));
chk_CO2_use("sum","MtCO2") = sum(j, chk_CO2_use(j,"MtCO2")) + chk_CO2_use("HHC","MtCO2");

chk_CO2_use(j,"%") = 100 * chk_CO2_use(j,"MtCO2") / chk_CO2_use("sum","MtCO2");
chk_CO2_use("HHC","%") = 100 * chk_CO2_use("HHC","MtCO2") / chk_CO2_use("sum","MtCO2");
chk_CO2_use("sum","%") = 100 * chk_CO2_use("sum","MtCO2") / chk_CO2_use("sum","MtCO2");

display chk_CO2_use;

chk_CO2_use_int(j,"tCO2/M.Yen")$chk_out_sec(j,"Value")
    = 1000 * chk_CO2_use(j,"MtCO2") / chk_out_sec(j,"Value");
chk_CO2_use_int(j,"tCO2/M.Yen(VA)")$chk_VA_sec(j,"Value")
    = 1000 * chk_CO2_use(j,"MtCO2") / chk_VA_sec(j,"Value");

display chk_CO2_use_int;

chk_ind_CO2_use(j,"DE") = chk_CO2_use(j,"MtCO2");
chk_ind_CO2_use("HHC","DE") = chk_CO2_use("HHC","MtCO2");
chk_ind_CO2_use("e_f","DE") = 0;
chk_ind_CO2_use("sum","DE") =
    sum(j, chk_ind_CO2_use(j,"DE")) + chk_ind_CO2_use("HHC","DE");

chk_ind_CO2_use(j,"IDE") =
    0.01 * chk_ely_use(j,"%") * chk_ind_CO2;
chk_ind_CO2_use("HHC","IDE") =
    0.01 * chk_ely_use("HHC","%") * chk_ind_CO2;
chk_ind_CO2_use("sum","IDE") =
    sum(j, chk_ind_CO2_use(j,"IDE")) + chk_ind_CO2_use("HHC","IDE");
    
chk_ind_CO2_use(j,"TE") = chk_ind_CO2_use(j,"DE") + chk_ind_CO2_use(j,"IDE");
chk_ind_CO2_use("HHC","TE") = chk_ind_CO2_use("HHC","DE") + chk_ind_CO2_use("HHC","IDE");
chk_ind_CO2_use("sum","TE") =
    sum(j, chk_ind_CO2_use(j,"TE")) + chk_ind_CO2_use("HHC","TE");

display chk_ind_CO2_use;

chk_ind_CO2_use_int(j,"tCO2/M.Yen")$chk_out_sec(j,"Value")
    = 1000 * chk_ind_CO2_use(j,"TE") / chk_out_sec(j,"Value");
chk_ind_CO2_use_int(j,"tCO2/M.Yen(VA)")$chk_VA_sec(j,"Value")
    = 1000 * chk_ind_CO2_use(j,"TE") / chk_VA_sec(j,"Value");

display chk_ind_CO2_use_int;

$if %bau_check% == 0 $goto model_def
execute_unload ".\results\bau_check.gdx",
    chk_VA_sec, chk_out_sec, chk_CO2_use, chk_CO2_use_int, chk_ind_CO2_use, chk_ely_use, chk_ind_CO2_use_int;
$if not %bau_check% == 0 $goto end

$label model_def

parameters
    fl_vla      Voluntary action
    fl_etr      Regulations by emissions trading
    fl_etr_e    ETRT镔傪P[XŔ[
;
fl_vla = 0;
fl_etr = 1;
fl_etr_e = 0;
display fl_vla, fl_etr, fl_etr_e;

parameter
    fl_vla_osub Voluntary action with output subsidy
;
* fl_vla_osub(j)$(reg_f(j) and co2_lim_f0(j)) = 1;
fl_vla_osub(j) = 0;
display fl_vla_osub;

*       f̋Lq

option sysout = on;

*    ------------------------------------------------------------
*    Model

$ontext

$model:jp_co2

*       Debug options for MPSGE
* $echop:.true.
* $datech:.true.
* $funlog:.true.
    
$sectors:
    q(j)$vq0(j)         ! Y
    adx(i)$vdo0(i)      ! EAo̔z
    af(i,j)$vintd0(i,j) ! Armingtoniԓj
    ac(i)$vcd0(i)       ! Armingtoniԏj
    ag(i)$vgd0(i)       ! Armingtoni{j
    ai(i)$vid0(i)       ! Armingtonij
    ae(j)$vae0(j)       ! Energy
    con                 ! ԏ
    gov                 ! {
    inv                 ! 
    ex(i)$vexp0(i)      ! Ao
    im(i)$vimp0(i)      ! A
    util                ! izIȁjp
    lsup                ! J
    rely(rene)$fl_rene(rene)    ! Đ\GlM[ɂ锭d
    
$commodities:
    p(i)                ! ̉i
    pd(i)$vdd0(i)       ! i
    px(i)$vdx0(i)       ! Aoi
    paf(i,j)$vintd0(i,j)        ! Armingtoniԓj
    pac(i)$vcd0(i)      ! Armingtoniԏj
    pag(i)$vgd0(i)      ! Armingtoni{j
    pai(i)$vid0(i)      ! Armingtonij
    pm(i)$vimp0(i)      ! Ải
    pae(j)$vae0(j)      ! Energy
    pl                  ! J̉i
    pls                 ! J̉i
    pk                  ! {̃^vCX
    pfx                 ! Oבւ̉i
    pgov                ! {̉i
    pcon                ! ԏ̉i
    pinv                ! ̉i
    putil               ! izIȁjp
    plnd(j)$vnd0(j)     ! yn̉i
    pres(j)$vrd0(j)     ! ̉i
    pco2                ! roi
    prene(rene)$fl_rene(rene)   ! Đ\GlM[p̎̉i

$consumers:
    m_hh                ! ƌv̏
    m_gov               ! {̏

$auxiliary:
    lumpt               ! ꊇ
    esl$fl_wc           ! J̒ߋ
    ur$fl_wc            ! Ɨ
    co2_e$fl_etr_e              ! T镔CO2

*       Energy
$prod:ae(j)$(vae0(j) and (not sen(j)))  s:e_ely(j)  ene:e_ene(j)
    o:pae(j)    q:vae0(j)
    i:paf(i,j)$e_nely(i) q:(vintd0(i,j)/tn_e(i,j))  p:(tn_e(i,j))  ene:
    i:paf(i,j)$ely(i)    q:(vintd0(i,j)/tn_e(i,j))  p:(tn_e(i,j))
    
*       Energy (for PET, COP and G_H)
$prod:ae(j)$(vae0(j) and sen(j))  s:e_ely(j)  ene:e_ene(j)
    o:pae(j)    q:vae0(j)
    i:paf(i,j)$e_ene_c(i,j)  q:(vintd0(i,j)/tn_e(i,j))  p:(tn_e(i,j))  ene:
    i:paf(i,j)$ely(i)  q:(vintd0(i,j)/tn_e(i,j))  p:(tn_e(i,j))

*       Yi_Ɓj
$prod:q(j)$(vq0(j) and agr(j))  t:0  s:e_lnd(j)  nld:0  kle(nld):e_kle(j)  kl(kle):e_kl(j)  
    o:p(i)      q:vqq0(i,j)     p:(1-rt_q0(j))  a:m_gov  t:rt_q(j)
    i:plnd(j)   q:vnd0(j)       
    i:paf(i,j)$(not ene(i))     q:vintd0(i,j)  nld:
    i:pae(j)    q:vae0(j)       kle:
    i:pl        q:(vld0(j)/tn_l(j))     p:((1+rt_l0(j))*tn_l(j))  a:m_gov  t:rt_l(j)  kl:
    i:pk        q:vkd0(j)       kl:

*       YiΔRj
$prod:q(j)$(vq0(j) and f_f(j))  t:0  s:e_res(j)  nrs:0  kle(nrs):e_kle(j)  kl(kle):e_kl(j)
    o:p(i)      q:vqq0(i,j)     p:(1-rt_q0(j))  a:m_gov  t:rt_q(j)
    i:pres(j)   q:vrd0(j)       
    i:paf(i,j)$(not ene(i))     q:vintd0(i,j)  nrs:
    i:pae(j)    q:vae0(j)       kle:
    i:pl        q:(vld0(j)/tn_l(j))     p:((1+rt_l0(j))*tn_l(j))  a:m_gov  t:rt_l(j)  kl:
    i:pk        q:vkd0(j)       kl:

*       Yid́j
$prod:q(j)$(vq0(j) and ely_s(j))  t:0  s:e_res(j)  nrs:0  kle(nrs):e_kle(j) kl(kle):e_kl(j)
    o:p(i)      q:vqq0(i,j)     p:(1-rt_q0(j))  a:m_gov  t:rt_q(j)
    i:pres(j)   q:vrd0(j)       
    i:paf(i,j)$(not ene(i))     q:vintd0(i,j)  nrs:
    i:pae(j)    q:vae0(j)       kle:
    i:pl        q:(vld0(j)/tn_l(j))     p:((1+rt_l0(j))*tn_l(j))  a:m_gov  t:rt_l(j)  kl:
    i:pk        q:vkd0(j)       kl:

*       YiPET, COP and G_Hj
$prod:q(j)$(vq0(j) and sen(j))  t:0  s:0  kle:e_kle(j)  kl(kle):e_kl(j)
    o:p(i)      q:vqq0(i,j)     p:(1-rt_q0(j))  a:m_gov  t:rt_q(j)
    i:paf(i,j)$(not ene(i))     q:vintd0(i,j)
    i:paf(i,j)$e_ene_nc(i,j)    q:vintd0(i,j)
    i:pae(j)    q:vae0(j)       kle:
    i:pl        q:(vld0(j)/tn_l(j))     p:((1+rt_l0(j))*tn_l(j))  a:m_gov  t:rt_l(j)  kl:
    i:pk        q:vkd0(j)       kl:

*       Yȋj
$prod:q(j)$(vq0(j) and oth_s(j))  t:0  s:0  kle:e_kle(j)  kl(kle):e_kl(j)
    o:p(i)      q:vqq0(i,j)     p:(1-rt_q0(j))  a:m_gov  t:rt_q(j)
    i:paf(i,j)$(not ene(i))     q:vintd0(i,j)
    i:pae(j)    q:vae0(j)       kle:
    i:pl        q:(vld0(j)/tn_l(j))     p:((1+rt_l0(j))*tn_l(j))  a:m_gov  t:rt_l(j)  kl:
    i:pk        q:vkd0(j)       kl:

*       Đ\GlM[ɂ锭d
$prod:rely(rene)$fl_rene(rene)  s:e_rene_res(rene)  nres:0
    o:p("ely")          q:(rq_rene(rene,"q")*tn_rene(rene))
    i:prene(rene)       q:rq_rene(rene,"res")
    i:paf(i,"e_h")      q:rq_rene(rene,i)      nres:
    i:pl                q:rq_rene(rene,"lab")  nres:
    i:pk                q:rq_rene(rene,"cap")  nres:

*       EAo̔z
$prod:adx(i)$vdo0(i)  t:e_des(i)
    o:px(i)     q:vdx0(i)
    o:pd(i)     q:vdd0(i)
    i:p(i)      q:vdo0(i)

*       Armingtoniԓj
$prod:af(i,j)$(vintd0(i,j) and (not es(i)))  s:e_dm(i)
    o:paf(i,j)  q:vintd0(i,j)
    i:pd(i)     q:vintdd0(i,j)
    i:pm(i)     q:vintdi0(i,j)

*       Armingtoniԓj
$prod:af(i,j)$(vintd0(i,j) and es(i))  s:0  dm:e_dm(i)
    o:paf(i,j)  q:vintd0(i,j)
    i:pco2$reg_f(j)      q:qco2(i,j)
    i:pd(i)     q:vintdd0(i,j)  dm:
    i:pm(i)     q:vintdi0(i,j)  dm:

*       Armingtoniԏj
$prod:ac(i)$(vcd0(i) and (not es(i)))  s:e_dm(i)
    o:pac(i)    q:vcd0(i)
    i:pd(i)     q:vcdd0(i)
    i:pm(i)     q:vcdi0(i)

*       Armingtoniԏj
$prod:ac(i)$(vcd0(i) and es(i))  s:0  dm:e_dm(i)
    o:pac(i)    q:vcd0(i)
    i:pco2$reg_c    q:qco2c(i)
    i:pd(i)     q:vcdd0(i)  dm:
    i:pm(i)     q:vcdi0(i)  dm:

*       Armingtoni{j
$prod:ag(i)$vgd0(i)  s:e_dm(i)
    o:pag(i)    q:vgd0(i)
    i:pd(i)     q:vgdd0(i)
    i:pm(i)     q:vgdi0(i)

*       Armingtonij
$prod:ai(i)$vid0(i)  s:e_dm(i)
    o:pai(i)    q:vid0(i)
    i:pd(i)     q:vidd0(i)
    i:pm(i)     q:vidi0(i)

*       ԏ
$prod:con  s:e_cc  ec:e_ec  nec:e_nec
    o:pcon      q:vcon0
    i:pac(i)$ene(i)             q:(vcd0(i)/tn_e(i,"hh"))  p:(tn_e(i,"hh"))   ec:
    i:pac(i)$(not ene(i))       q:vcd0(i)   nec:

*       {
$prod:gov  s:0
    o:pgov      q:vgov0
    i:pag(i)    q:vgd0(i)

*       
$prod:inv  s:0
    o:pinv      q:vinv0
    i:pai(i)    q:vid0(i)

*       Ao
$prod:ex(i)$vexp0(i)
    o:pfx       q:vexp0(i)
    i:px(i)     q:vexp0(i)

*       A    
$prod:im(i)$vimp0(i)
    o:pm(i)     q:vimp_0(i)
    i:pfx       q:vimp0(i)  p:(1+rt_m0(i))  a:m_gov  t:rt_m(i)

*       izIȁjp    
$prod:util  s:1
    o:putil     q:vutil0
    i:pcon      q:vcon0
    i:pinv$fl_vinv      q:vsave0
    i:pls$fl_vlsup      q:vlei0

*       J
$prod:lsup
    o:pl        q:vsup0
    i:pls       q:vsup0   a:m_gov  t:rt_li

*       --------------------------------------------------------------
*       ϐ

*       ƌv̏    
$demand:m_hh
    d:putil     q:vutil0
    e:pk        q:(end_cap*s_f)
    e:plnd(j)   q:(end_lnd(j)*s_f)
    e:pres(j)   q:(end_res(j)*s_f)
    e:prene(rene)$fl_rene(rene)  q:(end_rene(rene)*s_f)
    e:pd(i)     q:(-vdem_hh0(i)*s_f)
    e:pfx       q:(-vca0*s_f)
    e:pgov      q:(-vlumpt0)    r:lumpt
    e:pinv$(not fl_vinv)  q:(-vsave0*s_f)
    e:pls$(not fl_wc)   q:(end_lab*s_f*s_f_lab)
    e:pls$fl_wc         q:(end_lab_*s_f*s_f_lab)
    e:pls$fl_wc q:(-1)  r:esl
    
*       {̏
$demand:m_gov
    d:pgov      q:vgov0
    e:pgov      q:vlumpt0       r:lumpt
    e:pco2      q:(co2_lim)
    e:pco2$fl_etr_e    q:(-1)  r:co2_e

*       --------------------------------------------------------------
*       

*       ꊇł̐
$constraint:lumpt
    gov =e= s_f * s_f_g;

*       ----------------------------------------------------------------------
*       Constraint on real wage.
$constraint:ur$fl_wc
    pl / pcon =e= v0 * (ur / ur0)**(wc_elas);

*       Excess supply of labor.
$constraint:esl$fl_wc
    esl - ur * (end_lab_*s_f) =g= 0;

*       TĂ镔傩CO2
$constraint:co2_e$fl_etr_e
    co2_e =e=
    sum((i,j)$(es(i) and qco2(i,j) and (not reg_f(j))), qco2(i,j) * af(i,j))
    + sum(i$(es(i) and qco2c(i) and (not reg_c)), qco2c(i) * ac(i));

*       --------------------------------------------------------------
*       ̑̕ϐ̒`
$report:
    v:z_intd(i,j)       i:paf(i,j)      prod:q(j)       ! ԓv

$report:
    v:z_ld(j)   i:pl    prod:q(j)               ! Jv
    v:z_kd(j)   i:pk    prod:q(j)               ! {v
    v:z_nd(j)   i:plnd(j)       prod:q(j)       ! ynv
    v:z_rd(j)   i:pres(j)       prod:q(j)       ! ynv

$report:
    v:z_qq(i,j) o:p(i)          prod:q(j)       ! Yʁiʁj
    v:z_qdd(i)  o:pd(i)         prod:adx(i)     ! Y
    v:z_qdx(i)  o:px(i)         prod:adx(i)     ! YAo
    v:z_qd(i)   i:p(i)          prod:adx(i)     ! Y

$report:
    v:z_qrely(rene)  o:p("ely")  prod:rely(rene)  ! Đ\GlM[ɂ锭d

$report:
    v:z_ex_i(i) i:px(i)         prod:ex(i)      ! Ao
    v:z_im_i(i) i:pfx           prod:im(i)      ! A

$report:
    v:z_cd(i)   i:pac(i)        prod:con        ! ԏv
    v:z_gd(i)   i:pag(i)        prod:gov        ! {v
    v:z_id(i)$fl_vinv   i:pai(i)        prod:inv        ! v

$report:
    v:z_co2(i,j)$(reg_f(j) and es(i) and qco2(i,j))  i:pco2  prod:af(i,j)    ! CO2roʁiƁj
    v:z_co2c(i)$(reg_c and es(i) and qco2c(i))   i:pco2  prod:ac(i)         ! CO2roʁij

$report:
    v:z_util    o:putil         prod:util       ! zIȌp
    v:z_con     o:pcon          prod:con        ! ԏ
    v:z_inv$fl_vinv  o:pinv     prod:inv        ! 
    v:z_gov     o:pgov          prod:gov        ! {

$report:
    v:z_lsup    o:pl    prod:lsup       ! J
    v:z_lei$fl_vlsup     i:pls   prod:util       ! ]
    
$offtext
$sysinclude mpsgeset jp_co2

*       --------------------------------------------------------------
*       l
lumpt.lo = -inf;
lumpt.up = +inf;
lumpt.l = 1;

*       roi
pco2.l = 0;
* pco2f.l(j) = 0;
* pco2c.l = 0;

rely.l(rene) = 0;
prene.l(rene) = 0;

*       j[
pcon.fx = 1;

esl.l = 0 + unempr0$fl_wc;
esl.lo = -1e-1;
ur.l = ur0;
ur.lo = -1e-6;

* osub.l(j) = 0;
* osub.lo(j) = 0;


* $if not %fl_mcp%==0 $include sub_model_mcp.gms

*       ----------------------------------------------------------------------
*       Benchmark replication.
display "@ Benchmark replication";
jp_co2.iterlim = 0;

$include jp_co2.gen
solve jp_co2 using mcp;

*       ----------------------------------------------------------------------
*       Cleanup calculation.
display "@ Cleanup calculation";
jp_co2.iterlim = 10000;

$include jp_co2.gen
solve jp_co2 using mcp;

*       ----------------------------------------------------------------------
*       BAU
display "@ BAU";

$include jp_co2.gen
solve jp_co2 using mcp;

*       ----------------------------------------------------------------------
*       ETR
display "@ ETR";

co2_lim = co2_lim0 * 0.75;

fl_etr_e = 0;
reg_f(j) = yes;
reg_c = 1;

$include jp_co2.gen
solve jp_co2 using mcp;


*       ----------------------------------------------------------------------
*       ETR_A
display "@ ETR_A";

co2_lim = co2_lim0 * 0.75;

fl_etr_e = 1;
reg_f(j) = yes;
reg_f("i_s") = no;
reg_c = 1;

$include jp_co2.gen
solve jp_co2 using mcp;


*       ----------------------------------------------------------------------
*       ETR_CON
display "@ ETR_CON";

co2_lim = co2_lim0 * 0.75;

fl_etr_e = 1;
reg_f(j) = yes;
reg_c = 0;

$include jp_co2.gen
solve jp_co2 using mcp;






$exit


$ontext
*       ----------------------------------------------------------------------
*       Remove distortion
display "@ Remove distortion";

rt_q(j) = 0;
rt_l(j) = 0;
rt_li = 0;
rt_m(i) = 0;

$if not %fl_mpsge%==0 $include jp_co2.gen
solve jp_co2 using mcp;
$offtext

$include sub_results_parameters.gms

set     scn_all         /
        BAU             "BAU (reference scenario)"
        ETR             "CO2 reduction by emissions trading"
        VLA
        VLA_
        ETR_CON
        ETR_A
        ETR_B
        ETR_C
        /
        scn_solve(scn_all) /
        BAU
        ETR
        VLA
        VLA_
        ETR_CON
        ETR_A
        ETR_B
        ETR_C
        /
        scn_c(scn_all)
;
alias(scn,scn_solve);

*       ----------------------------------------------------------------------
*       Proportional shock
$ontext
display "@ Proportional shock";
s_f = 1.5;
$include jp_co2.gen
solve jp_co2 using mcp;
s_f = 1;
$offtext

$include ./sub_solve_model.gms

*       --------------------------------------------------------------
*       
display l_intd, l_cd, l_gd, l_id, l_ex_i, l_im_i, l_util, l_con, l_gov, l_inv,
        l_ex, l_im, l_im_, l_gdp, l_income, l_q;
display l_co2, l_co2_use, l_co2_use_sh, l_co2_so, l_co2t, l_co2_;
display l_pco2, l_pco2f, l_pco2c, l_pco2_;
display l_q_ely, l_q_ely_sh;
display l_ely_v, l_ely_q, l_ely_p, l_ely_c, l_ely_p_;
display l_ur;

parameter
    chk_l_co2
;

chk_l_co2(scn,i,j) = round(l_co2(scn,i,j) - l_co2_(scn,i,j), 4);
display chk_l_co2;
    
*       --------------------------------------------------------------
*       ω
pc_intd(i,j,scn)$l_intd(i,j,"bau")
    = 100 * (l_intd(i,j,scn) / l_intd(i,j,"bau") - 1) + eps;
pc_cd(i,scn)$l_cd(i,"bau") 
    = 100 * (l_cd(i,scn) / l_cd(i,"bau") - 1) + eps;
pc_gd(i,scn)$l_gd(i,"bau") 
    = 100 * (l_gd(i,scn) / l_gd(i,"bau") - 1) + eps;
pc_id(i,scn)$l_id(i,"bau") 
    = 100 * (l_id(i,scn) / l_id(i,"bau") - 1) + eps;
pc_ex_i(i,scn)$l_ex_i(i,"bau") 
    = 100 * (l_ex_i(i,scn) / l_ex_i(i,"bau") - 1) + eps;
pc_im_i(i,scn)$l_im_i(i,"bau") 
    = 100 * (l_im_i(i,scn) / l_im_i(i,"bau") - 1) + eps;

pc_util(scn)$l_util("bau") 
    = 100 * (l_util(scn) / l_util("bau") - 1) + eps;
pc_con(scn)$l_con("bau") 
    = 100 * (l_con(scn) / l_con("bau") - 1) + eps;
pc_gov(scn)$l_gov("bau") 
    = 100 * (l_gov(scn) / l_gov("bau") - 1) + eps;
pc_inv(scn)$l_inv("bau") 
    = 100 * (l_inv(scn) / l_inv("bau") - 1) + eps;
pc_ex(scn)$l_ex("bau") 
    = 100 * (l_ex(scn) / l_ex("bau") - 1) + eps;
pc_im(scn)$l_im("bau") 
    = 100 * (l_im(scn) / l_im("bau") - 1) + eps;
pc_im_(scn)$l_im_("bau") 
    = 100 * (l_im_(scn) / l_im_("bau") - 1) + eps;

pc_gdp(scn)$l_gdp("bau") 
    = 100 * (l_gdp(scn) / l_gdp("bau") - 1) + eps;
pc_income(scn)$l_income("bau") 
    = 100 * (l_income(scn) / l_income("bau") - 1) + eps;
pc_lsup(scn)$l_lsup("bau") 
    = 100 * (l_lsup(scn) / l_lsup("bau") - 1) + eps;
pc_lei(scn)$l_lei("bau") 
    = 100 * (l_lei(scn) / l_lei("bau") - 1) + eps;
pc_co2t(scn)$l_co2t("bau") 
    = 100 * (l_co2t(scn) / l_co2t("bau") - 1) + eps;
pc_q(j,scn)$l_q(j,"bau") 
    = 100 * (l_q(j,scn) / l_q(j,"bau") - 1) + eps;
pc_qd(i,scn)$l_qd(i,"bau") 
    = 100 * (l_qd(i,scn) / l_qd(i,"bau") - 1) + eps;
pc_q_(j,scn)$l_q_(j,"bau") 
    = 100 * (l_q_(j,scn) / l_q_(j,"bau") - 1) + eps;

display pc_intd, pc_cd, pc_gd, pc_id, pc_ex_i, pc_im_i, pc_util, pc_con, pc_gov,
        pc_inv, pc_ex, pc_im, pc_im_, pc_gdp, pc_income, pc_co2t, pc_q, pc_lsup,
        pc_lei, pc_qd, pc_q_;

d_qd(i,scn)$l_qd(i,"bau") = l_qd(i,scn) - l_qd(i,"bau") + eps;
d_q_(j,scn)$l_q_(j,"bau") = l_q_(j,scn) - l_q_(j,"bau") + eps;
display d_qd, d_q_;

display chk_pcon_m;

l_summary("CO2_",scn) = l_co2t(scn) + eps;
l_summary("PCO2(1000yen/t)",scn) = l_pco2(scn) + eps;
l_summary("INC_",scn) = l_income(scn) + eps;
l_summary("GDP_",scn) = l_gdp(scn) + eps;
l_summary("CON_",scn) = l_con(scn) + eps;
l_summary("GOV_",scn) = l_gov(scn) + eps;
l_summary("INV_",scn) = l_inv(scn) + eps;
l_summary("EX_",scn) = l_ex(scn) + eps;
l_summary("IM_",scn) = l_im_(scn) + eps;
l_summary("LSUP_",scn) = l_lsup(scn) + eps;
l_summary("LEI_",scn) = l_lei(scn) + eps;
l_summary("UTIL_",scn) = l_util(scn) + eps;
l_summary("UR_",scn) = l_ur(scn) + eps;
l_summary("PCO2_(1000yen/t)",scn) = l_pco2_(scn) + eps;

pc_summary("CO2_",scn) = pc_co2t(scn) + eps;
pc_summary("PCO2(1000yen/t)",scn) = l_pco2(scn) + eps;
pc_summary("INC_",scn) = pc_income(scn) + eps;
pc_summary("GDP_",scn) = pc_gdp(scn) + eps;
pc_summary("CON_",scn) = pc_con(scn) + eps;
pc_summary("GOV_",scn) = pc_gov(scn) + eps;
pc_summary("INV_",scn) = pc_inv(scn) + eps;
pc_summary("EX_",scn) = pc_ex(scn) + eps;
pc_summary("IM_",scn) = pc_im_(scn) + eps;
pc_summary("LSUP_",scn) = pc_lsup(scn) + eps;
pc_summary("LEI_",scn) = pc_lei(scn) + eps;
pc_summary("UTIL_",scn) = pc_util(scn) + eps;
pc_summary("UR_",scn) = l_ur(scn) + eps;
pc_summary("PCO2_(1000yen/t)",scn) = l_pco2_(scn) + eps;

l_summary_lst("CO2_",scn) = sum(t$t_lst(t), l_co2t(scn)) + eps;
l_summary_lst("PCO2(1000yen/t)",scn) = sum(t$t_lst(t), l_pco2(scn)) + eps;
l_summary_lst("INC_",scn) = sum(t$t_lst(t), l_income(scn)) + eps;
l_summary_lst("GDP_",scn) = sum(t$t_lst(t), l_gdp(scn)) + eps;
l_summary_lst("CON_",scn) = sum(t$t_lst(t), l_con(scn)) + eps;
l_summary_lst("GOV_",scn) = sum(t$t_lst(t), l_gov(scn)) + eps;
l_summary_lst("INV_",scn) = sum(t$t_lst(t), l_inv(scn)) + eps;
l_summary_lst("EX_",scn) = sum(t$t_lst(t), l_ex(scn)) + eps;
l_summary_lst("IM_",scn) = sum(t$t_lst(t), l_im_(scn)) + eps;
l_summary_lst("LSUP_",scn) = sum(t$t_lst(t), l_lsup(scn)) + eps;
l_summary_lst("LEI_",scn) = sum(t$t_lst(t), l_lei(scn)) + eps;
l_summary_lst("UTIL_",scn) = sum(t$t_lst(t), l_util(scn)) + eps;

pc_summary_lst("CO2_",scn) = sum(t$t_lst(t), pc_co2t(scn)) + eps;
pc_summary_lst("PCO2(1000yen/t)",scn) = sum(t$t_lst(t), l_pco2(scn)) + eps;
pc_summary_lst("INC_",scn) = sum(t$t_lst(t), pc_income(scn)) + eps;
pc_summary_lst("GDP_",scn) = sum(t$t_lst(t), pc_gdp(scn)) + eps;
pc_summary_lst("CON_",scn) = sum(t$t_lst(t), pc_con(scn)) + eps;
pc_summary_lst("GOV_",scn) = sum(t$t_lst(t), pc_gov(scn)) + eps;
pc_summary_lst("INV_",scn) = sum(t$t_lst(t), pc_inv(scn)) + eps;
pc_summary_lst("EX_",scn) = sum(t$t_lst(t), pc_ex(scn)) + eps;
pc_summary_lst("IM_",scn) = sum(t$t_lst(t), pc_im_(scn)) + eps;
pc_summary_lst("LSUP_",scn) = sum(t$t_lst(t), pc_lsup(scn)) + eps;
pc_summary_lst("LEI_",scn) = sum(t$t_lst(t), pc_lei(scn)) + eps;
pc_summary_lst("UTIL_",scn) = sum(t$t_lst(t), pc_util(scn)) + eps;
display l_summary, pc_summary;
display l_summary_lst, pc_summary_lst;

fit_summary(rene,"s_rate(%)",scn) = l_fit_sr(rene,scn);
fit_summary(rene,"sbs",scn) = l_fit_sbs(rene,scn);

fit_summary_lst(rene,"s_rate(%)",scn) 
    = 100 * sum(t$t_lst(t), fit_summary(rene,"s_rate(%)",scn));
fit_summary_lst(rene,"sbs",scn) 
    = sum(t$t_lst(t), fit_summary(rene,"sbs",scn));
display fit_summary, fit_summary_lst;

ely_summary("ely_v",all_e,scn) = l_ely_v(scn,all_e) + eps;
ely_summary("ely_v","sum_",scn) = l_ely_v(scn,"sum") + eps;
ely_summary("ely_q",all_e,scn) = l_ely_q(scn,all_e) + eps;
ely_summary("ely_q","sum_",scn) = l_ely_q(scn,"sum") + eps;
ely_summary("ely_p","price",scn) = l_ely_p(scn) + eps;
ely_summary("ely_v_sh(%)",all_e,scn)$ely_summary("ely_v","sum_",scn)
    = 100 * ely_summary("ely_v",all_e,scn) / ely_summary("ely_v","sum_",scn);
ely_summary("ely_q_sh(%)",all_e,scn)$ely_summary("ely_q","sum_",scn)
    = 100 * ely_summary("ely_q",all_e,scn) / ely_summary("ely_q","sum_",scn);

ely_summary_lst("ely_v",all_e,scn) 
    = sum(t$t_lst(t), ely_summary("ely_v",all_e,scn));
ely_summary_lst("ely_v","sum_",scn) 
    = sum(t$t_lst(t), ely_summary("ely_v","sum_",scn));
ely_summary_lst("ely_q",all_e,scn) 
    = sum(t$t_lst(t), ely_summary("ely_q",all_e,scn));
ely_summary_lst("ely_q","sum_",scn) 
    = sum(t$t_lst(t), ely_summary("ely_q","sum_",scn));
ely_summary_lst("ely_q_sh(%)",all_e,scn) 
    = sum(t$t_lst(t), ely_summary("ely_q_sh(%)",all_e,scn));
ely_summary_lst("ely_v_sh(%)",all_e,scn) 
    = sum(t$t_lst(t), ely_summary("ely_v_sh(%)",all_e,scn));
ely_summary_lst("ely_p","price",scn) 
    = sum(t$t_lst(t), ely_summary("ely_p","price",scn));

option ely_summary:1, ely_summary_lst:1;
display ely_summary, ely_summary_lst;

bau_check("CO2_") = l_summary("CO2_","bau");
bau_check("INC_") = l_summary("INC_","bau");
bau_check("GDP_") = l_summary("GDP_","bau");
* bau_check("CO2(AGR%)") = agr_co2t("bau");
* bau_check("GDP(AGR%)") = agr_gdp("bau");
bau_check("Ely_Q") = ely_summary("bau","ely_q","sum_");
bau_check("Ely_P") = ely_summary("bau","ely_p","price");

display bau_check;

execute_unload ".\results\%scn_name%_results.gdx", l_summary, pc_summary,
    l_summary_lst, pc_summary_lst, pc_q, l_q, pc_qd, d_qd, pc_q_, d_q_,
    ely_summary, ely_summary_lst, fit_summary, fit_summary_lst, bau_check;

$label end

execute 'del titlemaker_%scn_name%.cmd';



* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* coding: sjis-dos
* End:
