* gams-master-file: ./japan_model_main_static.gms
$title fR[h
display "@ fR[h";
$ontext
Time-stamp:     <2017-04-20 21:13:41 st>
First-written:  <2015-11-23>
$offtext

scn_c(scn_all) = no;

loop(scn$scn_solve(scn),

    scn_c(scn) = yes;

    co2_lim = co2_lim0 * 10;

*	ϐ̏    
$include ./sub_initialize.gms

*	ViIʂ̐̐ݒt@C    
$include ./scenarios/policy_settings.gms
    
$if not %fl_mpsge%==0 $include jp_co2.gen
    solve jp_co2 using mcp;

*	Walras' law ̃`FbN
    chk_pcon_m(scn) = round(pcon.m, 4);
    abort$chk_pcon_m(scn) "Walras' law is violated!!!", chk_pcon_m;

*	ʂ̑

    l_intd(i,j,scn) = z_intd.l(i,j);
    l_cd(i,scn) = z_cd.l(i);
    l_gd(i,scn) = z_gd.l(i);
    l_id(i,scn) = z_id.l(i);
    l_ex_i(i,scn) = z_ex_i.l(i);
    l_im_i(i,scn) = z_im_i.l(i);

    l_util(scn) = z_util.l;
    l_con(scn) = z_con.l;
    l_gov(scn) = z_gov.l;
    l_inv(scn)$fl_vinv = z_inv.l;
    l_inv(scn)$(not fl_vinv) = vsave0;

    l_ex(scn) = sum(i, l_ex_i(i,scn));
    l_im(scn) = sum(i, l_im_i(i,scn));
    l_im_(scn) = sum(i, (1 + rt_m0(i))*l_im_i(i,scn));

    l_nex(scn) = l_ex(scn) - l_im(scn);

    l_gdp(scn) =
        sum(i, l_cd(i,scn) + l_gd(i,scn) + l_id(i,scn)
            + l_ex_i(i,scn) - (1+rt_m0(i))*l_im_i(i,scn));

    l_lsup(scn) = z_lsup.l;

    l_co2_(scn,i,j) = z_co2.l(i,j);
    l_co2_(scn,i,"C") = z_co2c.l(i);
    l_co2_(scn,i,j)$(not reg_f(j)) = qco2(i,j) * af.l(i,j);
    
    l_co2(scn,i,j) = qco2(i,j) * af.l(i,j);
    l_co2(scn,i,"C") = qco2c(i) * ac.l(i);

    l_co2_use(scn,j) = sum(i, l_co2(scn,i,j));
    l_co2_use(scn,"F") = sum(j, l_co2_use(scn,j));
    l_co2_use(scn,"C") = sum(i, l_co2(scn,i,"C"));
    l_co2_use(scn,"sum") = sum(j, l_co2_use(scn,j)) + l_co2_use(scn,"C");
    l_co2_use_sh(scn,j) = l_co2_use(scn,j) / l_co2_use(scn,"sum");
    l_co2_use_sh(scn,"F") = l_co2_use(scn,"F") / l_co2_use(scn,"sum");
    l_co2_use_sh(scn,"C") = l_co2_use(scn,"C") / l_co2_use(scn,"sum");
    
    l_co2_so(scn,i) = sum(j, l_co2(scn,i,j)) + l_co2(scn,i,"C");

    l_co2t(scn) = sum(i, sum(j, l_co2(scn,i,j)) + l_co2(scn,i,"C"));

    l_pco2f(scn,j)$fl_vla = pco2f.l(j) / pcon.l;
    l_pco2c(scn)$fl_vla = pco2c.l / pcon.l;
    l_pco2_(scn)$fl_vla =
        ((sum(j, pco2f.l(j)*co2_lim_f(j)) + pco2c.l*co2_lim_c) /
        (sum(j, co2_lim_f(j)) + co2_lim_c)) / pcon.l;
        
    l_pco2(scn) = pco2.l / pcon.l;
    l_pco2(scn)$fl_vla = l_pco2_(scn);

    l_income(scn) =
        (pcon.l*z_con.l + (pinv.l*z_inv.l)$fl_vinv) / pcon.l;

    l_q_(j,scn) = sum(i, z_qq.l(i,j));
    l_q(j,scn) = q.l(j);
    l_qd(i,scn) = z_qd.l(i);

    l_trd(scn) = sum(i, l_ex_i(i,scn) - l_im_i(i,scn));

    l_ur(scn) = ur.l * 100;

    l_wage(scn) = pl.l / pcon.l;

    l_ld(j,scn) = z_ld.l(j);
    l_ld("sum",scn) = sum(j, l_ld(j,scn));

    l_kd(j,scn) = z_kd.l(j);
    l_kd("sum",scn) = sum(j, l_kd(j,scn));

    l_p(i,scn) = p.l(i) / pcon.l;

    l_pcon(scn) = pcon.l / p.l("agr");

    l_pfx(scn) = pfx.l / pcon.l;

    l_ae(j,scn)$vae0(j) = ae.l(j);

    scn_c(scn_all) = no;

);


* --------------------
* Local Variables:
* mode: gams
* coding: sjis-dos
* fill-column: 80
* End:
